package staging

import (
	StagingUser "BE-Epson/domains/staging/entities"
	"fmt"

	"gorm.io/gorm"
)

func StagingUsersSeeder(db *gorm.DB) error {

	stagingUsers := []StagingUser.StagingUser{

		{Name: "TUTUN CARYA ILMAYUDANDA", Nik: "9595113", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MIKA ROTUA", Nik: "9595277", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "SALMAN", Nik: "9595569", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "NARIYAH", Nik: "9595584", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ASEP ALI HARTONO", Nik: "9696104", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "FAJAR NUGROHO", Nik: "9696165", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ARIEL ANDRIANUR", Nik: "9696254", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ANI KHANIFAH", Nik: "9696267", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "DELYASTI HOPITRISNA P", Nik: "9696268", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "YANIMISTIYANI", Nik: "9717002", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MUTIK AFIFAH", Nik: "9717098", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "CUNCUN JOHARI", Nik: "9727011", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ISMAT SANIA", Nik: "9727032", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "EVI ZUFIANTI", Nik: "9727367", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "TRES DEWI KURNIASIH", Nik: "9727407", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "EKO SOETRISNO", Nik: "9797311", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "SUPRIHATIN", Nik: "9797491", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ZILDA ADRIANIS", Nik: "9797655", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MOCH.TAUFIK HIDAYAT", Nik: "9797879", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "DEWI NOVITA", Nik: "9898066", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "GIYATNO", Nik: "9898144", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "SARMAN", Nik: "9898225", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MUSBAKIR", Nik: "9898297", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "SLAMET NURJAMAN", Nik: "9898656", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "SULASTRI", Nik: "9898921", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "SYARIFUDDIN", Nik: "9899449", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "Alaudin", Nik: "9999054", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "IRFAN HIDAYAT", Nik: "9999075", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "BENNY YULYANTO", Nik: "9999630", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "INDRA RUDI BILLAH", Nik: "9999889", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "RISTENDI", Nik: "9999944", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "BENING ADI JAYA", Nik: "10000126", Department: ""},
		{Name: "DARMANATA", Nik: "10000155", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "HERI RIYANTARA", Nik: "10000169", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ALIYAH", Nik: "10000183", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ANJAR YULIYANTI WIDYASTUTI", Nik: "10000188", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MARIYAH", Nik: "10000278", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "DWI LESTARI", Nik: "10100072", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "LIA JUHLIA", Nik: "10101789", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "DENI SAEPUDIN", Nik: "10200703", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "RIZKO FERY", Nik: "10500006", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "PRIMA PUJA SAMAPTO", Nik: "10603150", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "EKA KRISWIDIANTORO", Nik: "10603152", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "AGUNG WIBOWO", Nik: "10706712", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ROMZI RAHMAN", Nik: "10706763", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MARSONO", Nik: "10800028", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "TRIANI AGUSTIN", Nik: "10800535", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "WAHYUDI RUSDIANTO", Nik: "10800542", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "TEGUH WIDODO", Nik: "10800547", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ALI FIKRI", Nik: "10804187", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "BOBY SETIAWAN", Nik: "10804199", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "YUSIFA USMAN", Nik: "10804807", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "AKHMAD AGUS KURNIAWAN", Nik: "10804925", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "DODY SUJOKO APRIAN AZMI", Nik: "10902417", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "DESY MAULIDIYANTI AMIN", Nik: "10903125", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "TORIQUL MAMAFIK", Nik: "10903794", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "AGUS WIBOWO", Nik: "11000119", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "IWAN MARTIN", Nik: "11000178", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "SYAMSUL MUIN", Nik: "11000179", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "RICKY YUSMANTA PUTRA", Nik: "11001757", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MISIRAN", Nik: "11001860", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "USI SUSANTI", Nik: "11004750", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "SINGGIH HARI WIBOWO", Nik: "11117035", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "YONES HABENGETAN", Nik: "12000199", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ASEP SAEPUDIN", Nik: "12020110", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "LIDOV PRASTOWO", Nik: "13070001", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "EKA MELLY AFIATI", Nik: "13073009", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "IRMANSYAH", Nik: "13085039", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ARIF RIZAL FANANI", Nik: "14025224", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "SYAHRUDDIN", Nik: "14025297", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MUHAMMAD RIDHO WIDI SANJAYA", Nik: "14100002", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "TEGAR ADHITYA MUKTI ALI", Nik: "14100004", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ADE KURNIAWAN", Nik: "14100006", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "YANUAR LINGGAR PRASTAWA U", Nik: "14110005", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "RECO HARLAIN", Nik: "14123026", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "DECKY DAMARA", Nik: "15030020", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "SIGIT ARIYANTO", Nik: "15030025", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "AMAN", Nik: "15035041", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "RISMANA", Nik: "15040014", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "RIDHA HERDIYANA", Nik: "15050007", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ALHDILA RIFQI BELLY", Nik: "15050010", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "M. ARI WIBOWO", Nik: "15050017", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "FARIDIANA FATMAWATI", Nik: "15051018", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "FADHIL ABDULLAH", Nik: "15100078", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "BILLY ABBIE OSMOND", Nik: "15100088", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "YUSMANSYAH", Nik: "15110034", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "SUGANDA", Nik: "15120003", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ISTIHARI LAKSMI NOERAISHA", Nik: "16030005", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "PUTRI WAHYUNING JATI", Nik: "16030011", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ARIF SUWANDHI", Nik: "16040003", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "INDRA WAHYU BUDIANTO", Nik: "16040010", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "LARAS SATI", Nik: "16044042", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "IBNU HIBBAN", Nik: "16045036", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "AHMAD IRFAN SATRIAWAN", Nik: "16090023", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "HUMAAM DZULHILMI", Nik: "16100005", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ZAENAL RASYID SHIDIQ", Nik: "17010016", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "AHMAD APRIANTO", Nik: "17010020", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MIRA EKA ANNISA", Nik: "17090014", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "AGUNG PRASETIO WIBOWO", Nik: "17110011", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MUHAMMAD WAHYU SATYA PRAJA", Nik: "18030023", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "NOPAL ANDRIYANTO", Nik: "18100003", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "HANA MARETA RACHMAWATI", Nik: "19010008", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "DESSY NURHAYATI", Nik: "19020003", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "IMAT SUTARMAN", Nik: "19040011", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "APRILLYA SUJARWATI PUTRI", Nik: "19050007", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "FADHIL HAWARI", Nik: "19060008", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "RIZKY EKA FIRDAUSI", Nik: "19060014", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ARNITA RAHMI", Nik: "19070012", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "FENY YULIANA ANDRIANI", Nik: "19070013", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "DEDE SOPIAN", Nik: "19070019", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "HABY PURWA ANUGRAH", Nik: "19080016", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ADHITIA HERMANSYAH", Nik: "19083001", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "DHELA ARDIANSYAH KURNIA ROSIDY", Nik: "19090012", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "NAFI'AN ZUKHRUFAL MUTTAQI", Nik: "19090013", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ANHAR TRIATMANTO", Nik: "19100012", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "M. KHOIRUL KHULUK", Nik: "19100018", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "RIZKY ESA PRATAMA", Nik: "19100021", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "SADELIH", Nik: "19105239", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "AKHMAD FATKHURROHMAN", Nik: "20010008", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ANGGA SUMARDALIN", Nik: "20010011", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ESA FARUQI DZIKRIAZ", Nik: "20010018", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "SARIFUDIN", Nik: "20055122", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "YAHYA SUBARKAH", Nik: "20065178", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "VICKY ATTALA IQBAL", Nik: "20065767", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "KARINA SALSABILA", Nik: "20071020", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "KHAIRUNNISSA NUR FAJRIN", Nik: "20090005", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "REGIF SATYA PRASAJA", Nik: "21030005", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "SUTARYA", Nik: "21070026", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "AHMAD FAUZI WIARTO", Nik: "21091001", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MUHAMMAD RIZKI ALFANSYAH", Nik: "21091015", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MOCHAMAD RAFLI NUR IRHAMSYAH", Nik: "21095021", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MOHAMAD RIDWAN", Nik: "21095022", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "EGO ADI NURJOYO", Nik: "21100019", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "FEBRI BUDI SANTOSO", Nik: "21100020", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "DEWI AYU NINGRUM", Nik: "21100035", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "NANDAR SUPRIATNA", Nik: "21101026", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "FENDY YUDAH FIRDIAN", Nik: "21110010", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "FARIS MUHAMMAD RAFI GUSRI", Nik: "21125133", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "HANUM YUDHA TRIATMOJO", Nik: "21125136", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MUHAMAD ILHAM", Nik: "21125149", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "NGUDI SUTRISNO", Nik: "21125155", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ITANO YUSUKE", Nik: "22030001", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "JAMAL SETIYADI", Nik: "22035773", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MUHAMAD HAMAS AL FAROBBY", Nik: "22035799", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ACHMAD FAUZAN DARMAWAN", Nik: "22085553", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "EKA IMAM YULYANTO", Nik: "22085554", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "FALDY APRI ANDOYO", Nik: "22085555", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "GILANG RAMADHAN DWI KURNIANTORO", Nik: "22085556", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "M. PUTRA PANATAGAMA", Nik: "22085557", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MUHAMAD NANANG WAHYU HARTA WIDODO", Nik: "22085558", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ASHRI OKTAVIANI", Nik: "22095329", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "TAUFIQUR ROHMAN", Nik: "22100005", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "ANANDA FIKRI NUGROHO", Nik: "22110002", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "AGUNG BUDI PAMUJI", Nik: "22111186", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "REFALDI", Nik: "22111187", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MUHAMMAD FARABI ANANDITO", Nik: "22115174", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "FARHAN MUHADZDZIB", Nik: "22120011", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "KEVIN HANDITYA PRADANA", Nik: "23010015", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "BRIAN ARDIANATA", Nik: "23040003", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MUHAMMAD NIZAM CHOIRUR RIZAK", Nik: "23040006", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "FRANSISKUS BIMA WIDI NUGROHO", Nik: "23070009", Department: "E4 PRODUCT ENGINEERING DEPT"},
		{Name: "MUHAMMAD SHOLAHUDDIN AL AYYUBI", Nik: "23070011", Department: "E4 PRODUCT ENGINEERING DEPT"},
	}
	for _, users := range stagingUsers {
		exists, err := userExists(db, users)
		if err != nil {
			return fmt.Errorf("error checking master existence: %w", err)
		}
		if !exists {
			if err := createUser(db, &users); err != nil {
				return fmt.Errorf("error creating master: %w", err)
			}
		}
	}
	return nil
}

func userExists(db *gorm.DB, user StagingUser.StagingUser) (bool, error) {
	var count int64
	if err := db.Model(&StagingUser.StagingUser{}).Where("nik = ?", user.Nik).Count(&count).Error; err != nil {
		return false, err
	}
	return count > 0, nil
}
func createUser(db *gorm.DB, user *StagingUser.StagingUser) error {
	if err := db.Create(&user).Error; err != nil {
		return err
	}
	return nil
}
